﻿$(function () {

    $("#ApiPopup").hide();
    $("#ApiPopup").draggable();

    $("#MailSendPopup").hide();
    $("#MailSendPopup").draggable();

    $("#MessagePopup").hide();
    $("#MessagePopup").draggable();

    $("#AddSubscribeList").hide();
    $("#AddSubscriberPopup").hide();
    $("#AddSubscriberPopup").draggable();

    $("#divStatus").hide();
    $("#txtFirstName").blur(function () {
        $("#txtFirstName").val($.trim($("#txtFirstName").val())); //trim FirstName on blur event
    });

    $("#txtLastName").blur(function () {
        $("#txtLastName").val($.trim($("#txtLastName").val())); //trim LastName on blur event
    });

    $("#txtEmail").blur(function () {
        $("#txtEmail").val($.trim($("#txtEmail").val())); //trim Email on blur event
    });

    //clientside click event of Subscribe button 
    $("#btnSubscribe").click(function () {
        if (Validate() == true) {
            DynamicShowPopup('ApiPopup', 'pageBackgroundPopup1', 'pagePopupClose');
            return false;
        }
        else
            return false;
    });

    //clientside click event for Submit button of divApiPopup
    $("#btnSubmit").click(function () {
 
        if ($("#txtApiKey").val() == "") {
            $("#lblApiMsg").text("Please enter APIkey value");
            return false;
        }
        else {
            $("#lblApiMsg").text("");
            $.ajax({
                type: "POST",
                url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/VerifyAPIKeyVal", //call method in webservice
                contentType: "application/json; charset=utf-8", //json type
                data: "{apiKey: '" + $('#txtApiKey').val() + "'}", //pass parameter
                dataType: "json",
                success: function (response) {
                    var jsond = $.parseJSON(response.d); //parse the response from webservive
                    //check result whether API Key is valid or not 
                    //if valid then open MailSendPopup
                    if ($(jsond)[0].Result == "Everything's Chimpy!") {
                        $("#drpList").empty();
                        $('#drpCatagory').empty()
                        $.ajax({
                            type: "POST",
                            url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/OpenMailSendPopup", //call method in webservice
                            contentType: "application/json; charset=utf-8", //json type
                            data: "{apiKey: '" + $('#txtApiKey').val() + "'}", //pass parameter
                            dataType: "json",
                            beforeSend: function () {
                                DynamicShowPopup('divStatus', 'pageBackgroundPopup1', 'pagePopupClose');
                            },
                            success: function (response) {
                                var jsond = $.parseJSON(response.d); //parse the response from webservive
                                //loop to bind json data to List dropdown 
                                for (i = 0; i < $(jsond).length; i++) {

                                    var id = $(jsond)[i].ListKey;
                                    var name = $(jsond)[i].ListValue;
                                    var catagory = $(jsond)[i].Catagory;
                                    var opt;
                                    if (catagory == "1") {
                                        opt = "<option value=" + id + ">" + name + "</option>";
                                        $("#drpList").append(opt);
                                    }
                                    else {
                                        opt = "<option value=" + id + ">" + name + "</option>";
                                        $("#drpCatagory").append(opt);
                                    }
                                }
                                $('#drpList option:first').before("<option selected='selected' value='0'>-----Select List-----</option>");
                                $('#drpCatagory option:first').before("<option selected='selected' value='0'>-----Select Catagory-----</option>");
                                $('#drpTemplate').empty().append('<option selected="selected" value="0">-----Select Template-----</option>');
                                CloseDynamicPopup('ApiPopup', 'pageBackgroundPopup1');
                                CloseDynamicPopup('divStatus', 'pageBackgroundPopup1');
                                DynamicShowPopup('MailSendPopup', 'pageBackgroundPopup1', 'pagePopupClose');

                            },

                            failure: function (response) {
                                alert("fail");
                            }
                        });

                    }
                    //else show alert
                    else if ($(jsond)[0].Result == "") {
                        alert("Please enter Valid API Key");
                        return false;
                    }
                },

                failure: function (response) {
                    alert("fail");
                }
            });
        }
    });

    //clientside change event for MailChimp List dropdown of MailSendPopup
    $("#drpList").live("change", function () {
        if ($("#lblAlertMessage").text != "") {
            $("#lblAlertMessage").text("");
        }
    });

    //clientside change event for Catagory dropdown of MailSendPopup
    $("#drpCatagory").live("change", function () {
        if ($('#drpCatagory').val() == "0") {
            $('#drpTemplate').empty().append('<option selected="selected" value="0">-----Select Template-----</option>');
        }
        else if ($("#drpList").val() == "0" || $("#drpList").val() == "") {
            $("#lblAlertMessage").text("Please select a list from MailChimp List");
            return false;
        }
        else {
            $("#lblAlertMessage").text("");
            $('#drpTemplate').empty();
            $.ajax({
                type: "POST",
                url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/BindTemplate", //call method in webservice
                contentType: "application/json; charset=utf-8", //json type
                data: "{apiKey: '" + $('#txtApiKey').val() + "', catagory: '" + $('#drpCatagory').val() + "'}", //pass parameter
                dataType: "json",
                success: function (response) {
                    var jsond = $.parseJSON(response.d); //parse the response from webservive
                    //loop to bind json data to Template dropdown
                    for (i = 0; i < $(jsond).length; i++) {

                        var id = $(jsond)[i].Id;
                        var name = $(jsond)[i].Name;

                        var opt = "<option value=" + id + ">" + name + "</option>";
                        $("#drpTemplate").append(opt);
                    }
                    $('#drpTemplate option:first').before("<option selected='selected' value='0'>-----Select Template-----</option>");
                },

                failure: function (response) {
                    alert("fail");
                }
            });
        }
    });

    //clientside change event for Template dropdown of MailSendPopup
    $("#drpTemplate").live("change", function () {
        $("#hidTemplateId").val($("#drpTemplate").val()); //store value in hidden field
    });

    //clientside validation on click event for SendMail button of MailSendPopup
    $("#btnClick").click(function () {

        if ($("#drpList").val() == "0" || $("#drpList").val() == "") {
            $("#lblAlertMessage").text("Please select a list from MailChimp List");
            return false;
        }

        if ($("#drpCatagory").val() == "0" || $("#drpCatagory").val() == null) {
            $("#lblAlertMessage").text("Please select a Catagory");
            return false;
        }

        if ($("#drpTemplate").val() == "0" || $("#drpTemplate").val() == null) {
            $("#lblAlertMessage").text("Please select a Template to send");
            return false;
        }

        if ($("#txtSubject").val() == "") {
            $("#lblAlertMessage").text("Please enter Subject for mail");
            return false;
        }

        else {
            $("#lblAlertMessage").text("");
            $("#hidListId").val($("#drpList").val()); //store value in hidden field
            $("#hidCatagory").val($("#drpCatagory").val()); //store value in hidden field
            $.ajax({
                type: "POST",
                url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/SubscriberExist", //call method in webservice
                contentType: "application/json; charset=utf-8", //json type
                data: "{apiKey: '" + $('#txtApiKey').val() + "', listId: '" + $('#drpList').val() + "'}", //pass parameter
                dataType: "json",
                success: function (response) {
                    var jsond = $.parseJSON(response.d); //parse the response from webservive
                    //loop to bind json data to List dropdown 
                    if ($(jsond)[0].Result == "0") {
                        $("#lblError").text(" There is no Subscriber present in the Selected MailChimp List. Please add Subscriber to List........ ");
                        CloseDynamicPopup('MailSendPopup', 'pageBackgroundPopup1');
                        DynamicShowPopup('MessagePopup', 'pageBackgroundPopup1', 'pagePopupClose');
                        return false;
                    }
                    else {
                        document.getElementById("btnSendMail").click();
                        return true;
                    }
                },

                failure: function (response) {
                    alert("fail");
                }
            });
        }
    });

    //clientside click event for Add button of MessagePopup
    $("#btnAdd").click(function () {
        CloseDynamicPopup('MessagePopup', 'pageBackgroundPopup1');
        DynamicShowPopup('AddSubscriberPopup', 'pageBackgroundPopup1', 'pagePopupClose');
    });

    //clientside click event for Cancel button of MessagePopup
    $("#btnCancel").click(function () {
        CloseDynamicPopup('MessagePopup', 'pageBackgroundPopup1');
        DynamicShowPopup('MailSendPopup', 'pageBackgroundPopup1', 'pagePopupClose');
    });

    //clientside change event for Radio button of AddSubscriberPopup
    $("#rdAddNew").live("change", function () {
        if ($(this).val()) {
            $("#AddSubscribeForm").show();
            $("#AddSubscribeList").hide();
        }
        else {
            $("#AddSubscribeForm").hide();
        }
    });

    //clientside change event for Radio button of AddSubscriberPopup
    $("#rdAddFromExcel").live("change", function () {
        if ($(this).val()) {
            $("#AddSubscribeList").show();
            $("#AddSubscribeForm").hide();
        }
        else {
            $("#AddSubscribeList").hide();
        }
    });

    $("#txtSubscribeFname").blur(function () {
        $("#txtSubscribeFname").val($.trim($("#txtSubscribeFname").val())); //trim Subscribe FirstName on blur event
    });

    $("#txtSubscribeLname").blur(function () {
        $("#txtSubscribeLname").val($.trim($("#txtSubscribeLname").val())); //trim Subscribe LastName on blur event
    });

    $("#txtSubscribeEmail").blur(function () {
        $("#txtSubscribeEmail").val($.trim($("#txtSubscribeEmail").val())); //trim Subscribe EmailId on blur event
    });

    //clientside validation on click event for AddSubscribe button of AddSubscriberPopup
    $("#btnAddSubscribe").click(function () {

        var email = $("#txtSubscribeEmail").val();
        var emailPattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
        var checkValidEmail = emailPattern.test(email);

        if ($("#txtSubscribeFname").val() == "") {
            $("#lblMsg").text("Please enter FirstName");
            return false;
        }

        if ($("#txtSubscribeLname").val() == "") {
            $("#lblMsg").text("Please enter LastName");
            return false;
        }

        if ($("#txtSubscribeEmail").val() == "") {
            $("#lblMsg").text("Please enter Eamil");
            return false;
        }

        if (checkValidEmail == false) {
            $("#lblMsg").text("Invalid email");
            return false;
        }

        else {
            $("#lblMsg").text("");
            $.ajax({
                type: "POST",
                url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/AddSubscriber", //call method in webservice
                contentType: "application/json; charset=utf-8", //json type
                data: "{apiKey: '" + $('#txtApiKey').val() + "', listId: '" + $('#hidListId').val() + "', subFname: '" + $('#txtSubscribeFname').val() + "', subLname: '" + $('#txtSubscribeLname').val() + "', subEmail: '" + $('#txtSubscribeEmail').val() + "'}", //pass parameter
                dataType: "json",
                success: function (response) {
                    var jsond = $.parseJSON(response.d); //parse the response from webservive
                    //loop to bind json data to List dropdown 
                    if ($(jsond)[0].Result == "True") {
                        //textfields value set to null
                        $('#txtSubscribeFname').text("");
                        $('#txtSubscribeLname').text("");
                        $('txtSubscribeEmail').text("");
                        CloseDynamicPopup('AddSubscriberPopup', 'pageBackgroundPopup1');
                        alert(" Subscriber has been added successfully.");
                        $("#lblError").text(" Want to add another Subscriber.......? ");
                        DynamicShowPopup('MessagePopup', 'pageBackgroundPopup1', 'pagePopupClose');
                        return false;
                    }
                    else {
                        alert(" Failed to add Subscriber. ");
                        DynamicShowPopup('AddSubscriberPopup', 'pageBackgroundPopup1', 'pagePopupClose');
                        return false;
                    }
                },

                failure: function (response) {
                    alert("fail");
                }
            });
        }
    });

    //clientside validation on click event for AddList button of AddSubscriberPopup
    $("#btnAddList").click(function () {

        if ($("#txtImportFile").val() == "") {
            $("#lblMsg").text("Please upload a Excel File");
            return false;
        }

        else {
            $("#lblMsg").text("");
            $.ajax({
                type: "POST",
                url: appPath + "CMSWebParts/MailChimp/MailChimp.asmx/AddSubscriberList", //call method in webservice
                contentType: "application/json; charset=utf-8", //json type
                data: "{apiKey: '" + $('#txtApiKey').val() + "', listId: '" + $('#hidListId').val() + "'}", //pass parameter
                dataType: "json",
                success: function (response) {
                    var jsond = $.parseJSON(response.d); //parse the response from webservive
                    //loop to bind json data to List dropdown 
                    if ($(jsond)[0].Result == "True") {
                        CloseDynamicPopup('AddSubscriberPopup', 'pageBackgroundPopup1');
                        alert(" Your SubscriberList has been added successfully ");
                        DynamicShowPopup('MailSendPopup', 'pageBackgroundPopup1', 'pagePopupClose');
                        return false;
                    }
                    else {
                        alert(" Failed to add SubscriberList ");
                        DynamicShowPopup('AddSubscriberPopup', 'pageBackgroundPopup1', 'pagePopupClose');
                        return false;
                    }
                },

                failure: function (response) {
                    alert("fail");
                }
            });
        }
    });

});

//clientside validation for FormPanel
function Validate() {

    var fName = $("#txtFirstName").val();
    var lName = $("#txtLastName").val();
    var email = $("#txtEmail").val();
    var emailPattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
    var checkValidEmail = emailPattern.test(email);
    
    if (fName == "") {
        $("#lblErrorMessage").text("Please enter First Name");
        return false;
    }
    if (lName == "") {
        $("#lblErrorMessage").text("Please enter Last Name");
        return false;
    }
    if (email == "") {
        $("#lblErrorMessage").text("Please enter Email address");
        return false;
    }
    if (checkValidEmail == false) {
        $("#lblErrorMessage").text("Invalid email");
        return false;
    }
    else {
        $("#lblErrorMessage").text("");
        return true;
    }
}

//clientside function to upload file during Browse button click
$(function () {
    var uploader = "";
    uploader = new AjaxUpload('#btnBrowse', {
        action: appPath + 'CMSWebParts/MailChimp/FileUploadHandler.ashx', //call handler class to save uploaded file
        autoSubmit: false,
        responseType: 'text/plain',
        onChange: function (file, exension) {
            file = file.replace(/ /g, '');
            //set the file name at TextField
            $("#txtImportFile").val(file);
            //check whether file extension is .xls or .xlsx
            if (!(exension && /^(xlsx|xls)$/i.test(exension))) {
                alert("Invalid File Format.");
                return false;
            }
            else {
                uploader.submit();
            }
        },
        onComplete: function (file, response) {
        },
        onSubmit: function (file, exension) { // check extension from client side
            if (!(exension && /^(xlsx|xls)$/i.test(exension))) {
                alert("Invalid File Format.");
                return false;
            }
        }
    });
});